_G[gTable] = {};

local aTmpVal = gTable;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 1;
end

-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)

end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

	if pObj.mState == 2 then
		if not pObj.mAlpha:AncIsChanging() then
			pObj.mIsDone = true;
		end
	end

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

   pObj.mDiscovered = true;
   if not cm.GetGlobalBoolIndirect(pObj, "ActivatorFlag1") then
      cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
      IcPlaySample("PH_SFX_DOES_NOT_WORK");
      if pName ~= "" then
         return false;
		end
      return true;
	end

	if pName == "" then

		if not cm.SpawnObject(pObj, 0, pObj.mSmPos, "SpawnObject") then
         return true;
      end

		pObj.mState = pObj.mState + 1;
		pObj.mAlpha:AncSetupChange(255.0, 0.0, PhSpawnerVanishAfterUse,
         IcAutoNumChgr.IC_ANCM_LINEAR);

      pObj.mDiscovered = false;
		pObj:SetActive(0, pPolyNum, false);
		IcPlaySample("PH_SFX_OBJ_PICKUP");
		return true;

	else

      pObj.mDiscovered = false;
		cm.ObjDoesNotWork(pObj);
		return false;

	end

	return false;

end


-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRpos = pObj.mSmPos;
	local aRect = aImg:GetCelRect(pObj.mCurCell);

	if (pObj.mState == 2) then
		pG:SetColorizeImages(true);
		pG:SetColor(Color(255, 255, 255, pObj.mAlpha:AncGetVal()));
	end
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

end





